"""adding_account_models

Revision ID: 418d7a2bcf5a
Revises: 
Create Date: 2021-02-23 13:08:28.512803

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = '418d7a2bcf5a'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.execute('create schema if not exists users')
    op.create_table('account',
    sa.Column('id', postgresql.UUID(as_uuid=True), nullable=False),
    sa.Column('modified_on', sa.DateTime(timezone=True), nullable=False),
    sa.Column('modified_by', postgresql.UUID(as_uuid=True), nullable=True),
    sa.Column('email', sa.String(length=255), nullable=False),
    sa.Column('password_hash', sa.String(length=255), nullable=False),
    sa.Column('is_active', sa.Boolean(), nullable=True),
    sa.Column('last_login_at', sa.DateTime(timezone=True), nullable=True),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('email'),
    schema='users'
    )
    op.create_index('idx_account_email_unique', 'account', ['email'], unique=True, schema='users')

    op.create_table('profile',
    sa.Column('id', postgresql.UUID(as_uuid=True), nullable=False),
    sa.Column('created_on', sa.DateTime(timezone=True), nullable=True),
    sa.Column('modified_on', sa.DateTime(timezone=True), nullable=True),
    sa.Column('account_id', postgresql.UUID(), nullable=True),
    sa.Column('email', sa.String(length=100), nullable=True),
    sa.Column('first_name', sa.String(length=128), nullable=False),
    sa.Column('last_name', sa.String(length=128), nullable=False),
    sa.Column('phone', sa.String(length=64), nullable=True),
    sa.Column('street', sa.String(length=128), nullable=True),
    sa.Column('city', sa.String(length=32), nullable=True),
    sa.Column('state', sa.String(length=30), nullable=True),
    sa.Column('country', sa.String(length=24), nullable=True),
    sa.Column('zip', sa.String(length=24), nullable=True),
    sa.ForeignKeyConstraint(['account_id'], ['users.account.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('email'),
    schema='users'
    )
    op.create_index('idx_profile_email_unique', 'profile', ['email'], unique=True, schema='users')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index('idx_profile_email_unique', table_name='profile', schema='users')
    op.drop_table('profile', schema='users')
    op.drop_index('idx_account_email_unique', table_name='account', schema='users')
    op.drop_table('account', schema='users')
    op.execute('drop schema if exists users')
    # ### end Alembic commands ###
